###############################################################################
### MAPPING:
###   SOURCE: {{ mapping["source"] }}
###   TARGET: {{ mapping["target"] }}
###############################################################################

{%- set proxy_headers = {} %}
{%- macro proxy_set_header(header, value) %}
{%- set _ = proxy_headers.update({header: value}) %}
{%- endmacro %}
{%- macro render_proxy_headers() %}
{%- for header, value in proxy_headers.items() %}
proxy_set_header {{ header|to_json }} {{ value|default("", true)|to_json }};
{%- endfor %}
{%- endmacro %}

{%- set resp_headers = {} %}
{%- macro resp_set_header(header, value) %}
{%- set _ = resp_headers.update({header: value}) %}
{%- endmacro %}
{%- macro render_resp_headers() %}
{%- for header, value in resp_headers.items() %}
add_header {{ header|to_json }} {{ value|default("", true)|to_json }} always;
{%- endfor %}
{%- endmacro %}

{%- set source_url = mapping["source"] %}
{%- set target_url = mapping["target"] %}

{%- set upstream_id = "{}_{}".format(source_url, target_url) | hash("md5") %}

{%- set target_scheme = target_url | urlsplit("scheme") %}
{%- set target_is_tls = true if target_scheme == 'https' else false %}
{%- set target_default_port = target_is_tls | ternary(443, 80) %}

{%- set target_host = target_url | urlsplit("hostname") %}
{%- set target_port = target_url | urlsplit("port") | default(target_default_port, true) %}

{%- set source_scheme = source_url | urlsplit("scheme") %}
{%- set source_is_tls = true if source_scheme == 'https' else false %}
{%- set source_default_port = source_is_tls | ternary(443, 80) %}

{%- set source_host = source_url | urlsplit("hostname") %}
{%- set source_port = source_url | urlsplit("port") | default(source_default_port, true) %}
{%- set source_explicit_port = source_url | urlsplit("port") %}

{%- set src_path = source_url | urlsplit("path") %}
{%- set tgt_path = target_url | urlsplit("path") %}

{%- if src_path is not regex("/$") %}
  {%- set src_path = src_path + "/" %}
  {%- set source_url = source_url + "/" %}
{%- endif %}
{%- if tgt_path is not regex("/$") %}
  {%- set tgt_path = tgt_path + "/" %}
  {%- set target_url = target_url + "/" %}
{%- endif %}

###############################################################################
### Reverse proxy configuration

{%- if src_path != "/" %}
location = {{ src_path[:-1] }} {
  rewrite ^ {{ src_path }} permanent;
}
{%- endif %}

location ~ {{ src_path }}(.*) {
  set $mapping_id {{ mapping["id"] }};
  set $mapping_source_path {{ src_path }};
  set $mapping_target_path {{ tgt_path }};

  {%- if nginx_plus_enabled and saml_enabled %}
  ##############################################################################
  ### SAML guard

  error_page 401 = @do_samlsp_flow;

  if ($saml_access_granted != "1") {
    return 401;
  }

  proxy_set_header {{ saml_config.auth_header_name }} $saml_name_id;
  {%- endif %}

  ##############################################################################
  ### ACL configuration

  {%- if mapping["acl_denied_source"] %}
  {%- for acl in mapping["acl_denied_source"] %}
  deny {{ acl["acl_source"] }};
  {%- endfor %}
  allow all;
  {%- endif %}

  ##############################################################################
  ### Proxy configuration

  js_import rewrite_engine from scripts.d/rewrite_engine.js;
  js_set $proxied_uri rewrite_engine.rewrite_uri;

  more_clear_headers Server;

  proxy_pass {{ target_scheme }}://{{ upstream_id }}$proxied_uri;
  {{- proxy_set_header("Host", "{}{}".format(source_host, source_explicit_port|ternary(":{}".format(source_port), ""))) }}
  {{- proxy_set_header("Client-IP", "$remote_addr") }}
  {{- proxy_set_header("X-Forwarded-Scheme", source_scheme) }}
  {{- proxy_set_header("X-Forwarded-Proto", source_scheme) }}
  {{- proxy_set_header("X-Forwarded-Host", "{}{}".format(source_host, source_explicit_port|ternary(":{}".format(source_port), ""))) }}
  {{- proxy_set_header("X-Forwarded-Port", "{}".format(service["port"])) }}
  {{- proxy_set_header("X-Forwarded-For", "$proxy_add_x_forwarded_for") }}
  {{- proxy_set_header("X-Real-Ip", "$remote_addr") }}

  {%- if "websocket" in mapping["extra_protocols"] %}
    {{- proxy_set_header("Upgrade", "$http_upgrade") }}
    {{- proxy_set_header("Connection", "upgrade") }}
  {%- else %}
    {{- proxy_set_header("Connection", "") }}
  {%- endif %}

  {%- for header in mapping["http_headers"] %}
    {%- if header["apply_to"] == "request" %}
      {{- proxy_set_header(header["name"], header["value"]) }}
    {%- elif header["apply_to"] == "response" %}
      {{- resp_set_header(header["name"], header["value"]) }}
    {%- endif %}
  {%- endfor %}

  {%- set dynatrace_header = source_url|regex_replace("https?:\/\/", "") %}
  {{- proxy_set_header("x-digitc-dynatrace", dynatrace_header) }}

  {%- if mapping["sorry_page"] %}
  error_page 500 502 503 504 =307 {{ mapping["sorry_page"] }};
  {%- else %}
  error_page 500 502 503 504 =307 $default_sorry;
  {%- endif %}

  proxy_redirect "{{ target_url }}" "{{ source_url }}";
  proxy_redirect "{{ target_scheme }}://{{ target_host }}:{{ target_port }}{{ tgt_path }}" "{{ source_scheme }}://{{ source_host }}:{{ source_port }}{{ src_path }}";

  proxy_redirect "https://ecas.cc.cec.eu.int:7002/cas" "https://ecas.ec.europa.eu/cas";

  ## HTTP Request Headers sent to the upstream server
  {{ render_proxy_headers() | indent(2) }}

  ## HTTP Response Headers sent to the client
  {{ render_resp_headers() | indent(2) }}

  ##############################################################################
  ### Buffering configuration

  {%- if mapping["proxy_buffer_requests"] %}
  proxy_request_buffering on;
  {%- else %}
  proxy_request_buffering off;
  {%- endif %}

  {%- if mapping["proxy_buffer_responses"] %}
  proxy_buffering on;
  {%- else %}
  proxy_buffering off;
  {%- endif %}

  ##############################################################################
  ### Cache configuration

  {%- if not mapping["proxy_cache"] %}
  proxy_cache off;
  {%- endif %}

  {%- if nginx_plus_enabled %}
  proxy_cache_purge $cache_purge;
  location ~ \*$ {
    return 204;
  }
  {%- endif %}

  proxy_no_cache $proxy_cache_bypass;
  proxy_cache_bypass $proxy_cache_bypass;

  {%- for cache in mapping["cache_configs"] %}
  location ~* \.(?:{{ cache["list_extensions"] | join("|") }})$ {

    js_import cache_control from scripts.d/cache_control.js;
    js_var $max_size {{ cache["max_size_limit"] }};

    add_header X-Cache-Status $upstream_cache_status;
    js_header_filter cache_control.check_cache;
    expires {{ cache["ttl"] }}s;
    proxy_cache my_cache;
    proxy_cache_valid 200 2m;
    add_header Cache-Control "public, max-age=120";
  }
  {%- endfor %}

  ##############################################################################
  ### HSTS configuration
  {%- set hsts = mapping["hsts_protocol"] %}

  {%- if hsts is not none %}
    add_header Strict-Transport-Security "max-age={{ hsts.max_age }}{% if hsts.subdomains %}; includeSubdomains {% endif %}{% if hsts.preload_flag %}; preload{% endif %}";
  {%- endif %}

  ##############################################################################
  ### Timeout configuration

  keepalive_timeout  {{ mapping["keepalive_timeout"] }};
  keepalive_requests  {{ mapping["keepalive_requests"] }};

  proxy_read_timeout {{ mapping["proxy_read_timeout"] }}s;

  ##############################################################################
  ### Compression configuration

  {%- if mapping["gzip_proxied"] %}
  gzip_proxied any;
  {%- else %}
  gzip_proxied off;
  {%- endif %}

  ##############################################################################
  ### Request constraints configuration

  client_max_body_size {{ mapping["client_max_body_size"] }}M;
}
